#include <vector>
#include <unordered_map>

using namespace std;

/*
	oNX
*/
template <class T>
class Diff {
private:
	T a;
	T b;
	int m;
	int n;

	struct Vmap {
	public:
		Vmap(int _x = 0, int _y = 0, Vmap *_parent = nullptr) {
			m_x = _x;
			m_y = _y;
			m_parent = _parent;
		}
		int x() const {return m_x;}
		int y() const {return m_y;}
		Vmap *parent() {return m_parent;}
		const Vmap *parent() const {return m_parent;}

	private:
		int m_x;
		int m_y;
		Vmap *m_parent;
	};
	vector<Vmap*> v;
	vector<Vmap*> stock;

	Vmap *getVmap(int index) {
		if(v[index] == nullptr) {
			Vmap *vm = new Vmap();
			stock.push_back(vm);
			v[index] = vm;
		}
		return v[index];
	}

public:
	Diff(const T &a, const T &b) : a(a), b(b), m(static_cast<int>(a.size())), n(static_cast<int>(b.size())), v(m + n + 1), stock(2*(m+n)) {}
	~Diff() {
		// stockvmap
		vector<Vmap*>::iterator it;
		for(it = stock.begin(); it != stock.end(); it++) {
			delete *it;
		}
	}

	Vmap *getEndPoint() {
		int offset = m;
		int k_min = 1;
		int k_max = -1;
		for (int d = 0; d <= m + n; d++) {
			if(d <= m) {k_min--;} else {k_min++;}
			if(d <= n) {k_max++;} else {k_max--;}
			for (int k = k_min; k <= k_max; k+=2) {
				int index = offset + k;
				int y = -1;
				Vmap *parent = nullptr;
				if(k == -d || (k != d && getVmap(index - 1)->y() < getVmap(index + 1)->y())) {
					y = getVmap(index + 1)->y();
					parent = v[index + 1];
				}
				else {
					y = getVmap(index - 1)->y() + 1;
					parent = v[index - 1];
				}
				int x = y - k;
				while (x < m && y < n && a[x] == b[y]) {
					x++;
					y++;
				}
				Vmap *vm = new Vmap(x, y, parent);
				stock.push_back(vm);
				v[index] = vm;
				if(x >= m && y >= n) {
					return vm;
				}
			}
		}
		return nullptr;
	}

	int getDiff(unordered_map<int, int> &vecdiffmap) {
		Vmap *point = getEndPoint();
		while (point->parent() != nullptr) {
			Vmap *parent = point->parent();
			int diff_x = point->x() - parent->x();
			int diff_y = point->y() - parent->y();
			int same_len = min(diff_x, diff_y);
			for(int i = 0; i < same_len; i++) {
				// _
				int vsrcindex = a[point->x() - i - 1].getindex();
				int vdstindex = b[point->y() - i - 1].getindex();
				vecdiffmap.insert(pair<int, int>(vdstindex, vsrcindex));
			}
			if(diff_x < diff_y) {
				// ǉꂽ_
				int vdstindex = b[parent->y()].getindex();
				vecdiffmap.insert(pair<int, int>(vdstindex, -1));
			}
			else if(diff_x > diff_y) {
				// 폜ꂽ_
			}
			point = point->parent();
		}
		return 0;
	}
};
